<?php  // $Id: lib.php,v 1.4 2006/08/28 16:41:20 mark-nielsen Exp $
/**
 * Library of functions and constants for module projects
 *
 * @author 
 * @version $Id: lib.php,v 1.4 2006/08/28 16:41:20 mark-nielsen Exp $
 * @package projects
 **/

/// (replace projects with the name of your module and delete this line)


$projects_CONSTANT = 7;     /// for example

/**
 * Given an object containing all the necessary data, 
 * (defined by the form in mod.html) this function 
 * will create a new instance and return the id number 
 * of the new instance.
 *
 * @param object $instance An object from the form in mod.html
 * @return int The id of the newly inserted projects record
 **/
function projects_add_instance($projects) {

	$projects->timemodified = time();

	# May have to add extra stuff in here #

	return insert_record("projects", $projects);
}

/**
 * Given an object containing all the necessary data, 
 * (defined by the form in mod.html) this function 
 * will update an existing instance with new data.
 *
 * @param object $instance An object from the form in mod.html
 * @return boolean Success/Fail
 **/
function projects_update_instance($projects) {

	$projects->timemodified = time();
	$projects->id = $projects->instance;

	# May have to add extra stuff in here #

	return update_record("projects", $projects);
}

/**
 * Given an ID of an instance of this module, 
 * this function will permanently delete the instance 
 * and any data that depends on it. 
 *
 * @param int $id Id of the module instance
 * @return boolean Success/Failure
 **/
function projects_delete_instance($id) {

	if (! $projects = get_record("projects", "id", "$id")) {
		return false;
	}

	$result = true;

	# Delete any dependent records here #

	if (! delete_records("projects", "id", "$projects->id")) {
		$result = false;
	}

	return $result;
}

/**
 * Return a small object with summary information about what a 
 * user has done with a given particular instance of this module
 * Used for user activity reports.
 * $return->time = the time they did it
 * $return->info = a short text description
 *
 * @return null
 * @todo Finish documenting this function
 **/
function projects_user_outline($course, $user, $mod, $projects) {
	return $return;
}

/**
 * Print a detailed representation of what a user has done with 
 * a given particular instance of this module, for user activity reports.
 *
 * @return boolean
 * @todo Finish documenting this function
 **/
function projects_user_complete($course, $user, $mod, $projects) {
	return true;
}

/**
 * Given a course and a time, this module should find recent activity 
 * that has occurred in projects activities and print it out. 
 * Return true if there was output, or false is there was none. 
 *
 * @uses $CFG
 * @return boolean
 * @todo Finish documenting this function
 **/
function projects_print_recent_activity($course, $isteacher, $timestart) {
	global $CFG;

	return false;  //  True if anything was printed, otherwise false 
}

/**
 * Function to be run periodically according to the moodle cron
 * This function searches for things that need to be done, such 
 * as sending out mail, toggling flags etc ... 
 *
 * @uses $CFG
 * @return boolean
 * @todo Finish documenting this function
 **/
function projects_cron () {
	global $CFG;

	return true;
}

/**
 * Must return an array of grades for a given instance of this module, 
 * indexed by user.  It also returns a maximum allowed grade.
 * 
 * Example:
 *    $return->grades = array of grades;
 *    $return->maxgrade = maximum allowed grade;
 *
 *    return $return;
 *
 * @param int $projectsid ID of an instance of this module
 * @return mixed Null or object with an array of grades and with the maximum grade
 **/
function projects_grades($projectsid) {
	return NULL;
}

/**
 * Must return an array of user records (all data) who are participants
 * for a given instance of projects. Must include every user involved
 * in the instance, independient of his role (student, teacher, admin...)
 * See other modules as example.
 *
 * @param int $projectsid ID of an instance of this module
 * @return mixed boolean/array of students
 **/
function projects_get_participants($projectsid) {
	return false;
}

/**
 * This function returns if a scale is being used by one projects
 * it it has support for grading and scales. Commented code should be
 * modified if necessary. See forum, glossary or journal modules
 * as reference.
 *
 * @param int $projectsid ID of an instance of this module
 * @return mixed
 * @todo Finish documenting this function
 **/
function projects_scale_used ($projectsid,$scaleid) {
	$return = false;

	//$rec = get_record("projects","id","$projectsid","scale","-$scaleid");
	//
	//if (!empty($rec)  && !empty($scaleid)) {
	//    $return = true;
	//}

	return $return;
}

//////////////////////////////////////////////////////////////////////////////////////
/// Any other projects functions go here.  Each of them must have a name that 
/// starts with projects_

function projects_get_theme_table(&$course, &$group, &$cm) {
	global $USER;
	global $CFG;
	$groupname = groups_get_group_name($group->id);
	$ist = isteacher($cm->course);
	$user_tema = get_record('projects_user_temy', 'user_id', $USER->id);
	$user_odovzdana_tema = get_record('projects_odovzdane_temy', 'user_id', $USER->id, 'course_id', $course->id);
	$users_temy = get_records_sql('select t.*, u.firstname, u.lastname, u.id as uid, ot.doc_file from mdl_projects_temy t LEFT JOIN (mdl_projects_user_temy ut, mdl_user u, mdl_groups_members g) ON (t.id = ut.tema_id AND ut.user_id = u.id AND g.userid = u.id AND g.groupid = '.$group->id.') LEFT JOIN (mdl_projects_odovzdane_temy ot) ON (u.id = ot.user_id)');

	$table = '<div style="float:left;margin-left:40px;margin-top:40px;"><table border="1" cellpadding="5">';
	$table .= '<tr><th colspan="3">Skupina '.$groupname.'</th></tr>';
	$table .= '<tr><th>Číslo</th><th>Názov témy</th><th>Študent</th></tr>';

	if($users_temy) {
		$i = 0;
		foreach($users_temy as &$t) {
			$i++;
			$tema_reg = '';

			if($ist ) {
				if($t->uid) {
					$tema_reg = "$t->firstname&nbsp;$t->lastname";
					if($t->doc_file) {
						$t->doc_file = htmlspecialchars($t->doc_file);
						$tema_reg .= " (<a href=\"file.php?id=$cm->id&a=down&uid=$t->uid\">stiahnuť</a>)";
						//$tema_reg .= " (<a href=\"$CFG->wwwroot/mod/projects/odovzdane_subory/$t->doc_file\">stiahnuť</a>)";
					}
				} else $tema_reg = "&nbsp;";
			} else {
				if($user_tema) {
					if($USER->id == $t->uid) {

						$odovzdaj_msg = '';
						if($user_odovzdana_tema) $odovzdaj_msg = "odovzdané";
						else $odovzdaj_msg = "<a href=\"file.php?id=$cm->id&a=up\">odovzdať</a>";

						$tema_reg = "<strong>$t->firstname&nbsp;$t->lastname</strong>&nbsp;($odovzdaj_msg)";
					} else
						$tema_reg = "$t->firstname&nbsp;$t->lastname";
				} else {
					if($t->uid) $tema_reg = "$t->firstname&nbsp;$t->lastname";
					else $tema_reg = '<a href="view.php?id='.$cm->id.'&tema_reg='.$t->id.'">registruj</a>';
				}
			}

			$table .= '<tr><td>'.$i.'</td><td>'.$t->nazov.'</td><td>'.$tema_reg.'</td></tr>';
		}
	}

	/*
	$table .= '<tr><td>1</td><td>Riadenie prístupu v OS Windows XP</td><td><a href="#">registruj</a></td></tr>';
	$table .= '<tr><td>2</td><td>Riadenie prístupu v OS UNIX</td><td><a href="#">registruj</a></td></tr>';
	$table .= '<tr><td>3</td><td>Forenzné nástroje na zber stálych digitálnych dôkazov</td><td><a href="#">registruj</a></td></tr>';
	$table .= '<tr><td>4</td><td>Forenzné nástroje na zber nestálych digitálnych dôkazov</td><td><a href="#">registruj</a></td></tr>';
	$table .= '<tr><td>5</td><td>Vírusové infiltrácie</td><td><a href="#">registruj</a></td></tr>';
	$table .= '<tr><td>6</td><td>Infraštruktúra verejného kľúča (PKI)</td><td><a href="#">registruj</a></td></tr>';
	$table .= '<tr><td>7</td><td>Bezpečnosť čipových kariet</td><td><a href="#">registruj</a></td></tr>';
	$table .= '<tr><td>8</td><td>Metódy identifikácie a autentizácie používateľov</td><td><a href="#">registruj</a></td></tr>';
	$table .= '<tr><td>9</td><td>Bezpečnosť v databáze PosgreSQL</td><td><a href="#">registruj</a></td></tr>';
	$table .= '<tr><td>10</td><td>Bezpečnosť v bezdrátových (wireless) LAN</td><td><a href="#">registruj</a></td></tr>';
	$table .= '<tr><td>11</td><td>Personálne bezpečnostné brány</td><td><a href="#">registruj</a></td></tr>';
	$table .= '<tr><td>12</td><td>Auditné záznamy - nastavenie politiky, filtrovanie, vyhodnocovanie</td><td><a href="#">registruj</a></td></tr>';
	 */

	$table .= '</table></div>';

	return $table;
}

function projects_temy_table(&$course, &$cm) {
	$temy = get_records('projects_temy', 'course_id', $course->id);

	$table = '<div style="float:left;margin-left:40px;margin-top:40px;"><table border="1" cellpadding="5">';
	$table .= '<tr><th>Číslo</th><th>Názov témy</th><th>&nbsp;</th></tr>';

	if($temy) {
		$i = 0;
		foreach($temy as &$t) {
			$i++;
			$table .= '<tr><td>'.$i.'</td><td>'.$t->nazov.'</td><td><a href="view.php?id='.$cm->id.'&action=1&tema_del='.$t->id.'">zmazať</a></td></tr>';
		}
	}

	/*
	$table .= '<tr><td>1</td><td>Riadenie prístupu v OS Windows XP</td><td><a href="#">registruj</a></td></tr>';
	$table .= '<tr><td>2</td><td>Riadenie prístupu v OS UNIX</td><td><a href="#">registruj</a></td></tr>';
	$table .= '<tr><td>3</td><td>Forenzné nástroje na zber stálych digitálnych dôkazov</td><td><a href="#">registruj</a></td></tr>';
	$table .= '<tr><td>4</td><td>Forenzné nástroje na zber nestálych digitálnych dôkazov</td><td><a href="#">registruj</a></td></tr>';
	$table .= '<tr><td>5</td><td>Vírusové infiltrácie</td><td><a href="#">registruj</a></td></tr>';
	$table .= '<tr><td>6</td><td>Infraštruktúra verejného kľúča (PKI)</td><td><a href="#">registruj</a></td></tr>';
	$table .= '<tr><td>7</td><td>Bezpečnosť čipových kariet</td><td><a href="#">registruj</a></td></tr>';
	$table .= '<tr><td>8</td><td>Metódy identifikácie a autentizácie používateľov</td><td><a href="#">registruj</a></td></tr>';
	$table .= '<tr><td>9</td><td>Bezpečnosť v databáze PosgreSQL</td><td><a href="#">registruj</a></td></tr>';
	$table .= '<tr><td>10</td><td>Bezpečnosť v bezdrátových (wireless) LAN</td><td><a href="#">registruj</a></td></tr>';
	$table .= '<tr><td>11</td><td>Personálne bezpečnostné brány</td><td><a href="#">registruj</a></td></tr>';
	$table .= '<tr><td>12</td><td>Auditné záznamy - nastavenie politiky, filtrovanie, vyhodnocovanie</td><td><a href="#">registruj</a></td></tr>';
	 */

	$table .= '</table></div>';

	return $table;
}

function projects_tema_pridaj (&$course, &$tema) {
	$data = new object();

	$data->course_id = $course->id;
	$data->nazov = $tema;

	return insert_record("projects_temy", $data, false);
}

function projects_tema_register(&$tema) {
	global $USER;
	$data = new object();

	$data->user_id = $USER->id;
	$data->tema_id = $tema;

	return insert_record("projects_user_temy", $data, false);
}

function projects_tema_odovzdat (&$course, &$doc_file) {
	global $USER;
	$data = new object();
	$t = get_record('projects_user_temy', 'user_id', $USER->id);

	$data->course_id = $course->id;
	$data->user_id = $USER->id;
	$data->tema_id = $t->tema_id;
	$data->doc_file = $doc_file;

	return insert_record("projects_odovzdane_temy", $data, false);
}

function projects_tema_delete(&$course, &$tema) {
	//global $USER;

	/*
	$u = get_record('projects_user_temy', 'user_id', $USER->id);
	print "je rovnake: ".$USER->id." a ".$u->id."\n";
	 */

	delete_records('projects_odovzdane_temy', 'tema_id', $tema);
	delete_records('projects_user_temy', 'tema_id', $tema);
	return delete_records('projects_temy', 'id', $tema);
}

/*
function projects_ () {
}
 */
?>
