<?php  // $Id: view.php,v 1.4 2006/08/28 16:41:20 mark-nielsen Exp $
/**
 * This page prints a particular instance of projects
 * 
 * @author 
 * @version $Id: view.php,v 1.4 2006/08/28 16:41:20 mark-nielsen Exp $
 * @package projects
 **/

/// (Replace projects with the name of your module)

    require_once("../../config.php");
    require_once("lib.php");

    $id = optional_param('id', 0, PARAM_INT); // Course Module ID, or
    $a  = optional_param('a', 0, PARAM_INT);  // projects ID

    if ($id) {
        if (! $cm = get_record("course_modules", "id", $id)) {
            error("Course Module ID was incorrect");
        }
    
        if (! $course = get_record("course", "id", $cm->course)) {
            error("Course is misconfigured");
        }
    
        if (! $projects = get_record("projects", "id", $cm->instance)) {
            error("Course module is incorrect");
        }

    } else {
        if (! $projects = get_record("projects", "id", $a)) {
            error("Course module is incorrect");
        }
        if (! $course = get_record("course", "id", $projects->course)) {
            error("Course is misconfigured");
        }
        if (! $cm = get_coursemodule_from_instance("projects", $projects->id, $course->id)) {
            error("Course Module ID was incorrect");
        }
    }

    require_login($course->id);

    add_to_log($course->id, "projects", "view", "view.php?id=$cm->id", "$projects->id");

/// Print the page header

    if ($course->category) {
        $navigation = "<a href=\"../../course/view.php?id=$course->id\">$course->shortname</a> ->";
    } else {
        $navigation = '';
    }

    $strprojectss = get_string("modulenameplural", "projects");
    $strprojects  = get_string("modulename", "projects");

    print_header("$course->shortname: $projects->name", "$course->fullname",
                 "$navigation <a href=index.php?id=$course->id>$strprojectss</a> -> $projects->name", 
                  "", "", true, update_module_button($cm->id, $course->id, $strprojects), 
                  navmenu($course, $cm));

/// Print the main part of the page


    $isteach = isteacher($cm->course);
    // Teacher Operation
   
    if($isteach) echo '<ul><li><a href="view.php?id='.$cm->id.'">Pridelené projekty</a></li><li><a href="view.php?id='.$cm->id.'&action=1">Správa projektov</a></li></ul><br />';

    echo '<h1>Pridelovanie projektov</h1><br />';

    if($isteach) {

	    // pridavanie tem ucitelmi
	    
	    if(optional_param('tema_pridaj') && ($tema = required_param('tema')) && !empty($tema)) projects_tema_pridaj($course, $tema);
	    
            // mazanie tem ucitelmi

	    if(($tema = optional_param('tema_del')) && is_numeric($tema)) projects_tema_delete($course, $tema);

	    if($action = optional_param('action')) {
		    switch($action) {
		    	case 1:
	    			echo "<form action=\"view.php?id=$cm->id&action=1\" method=\"POST\">Názov novej témy: <input type=\"text\" name=\"tema\"/><input type=\"submit\" name=\"tema_pridaj\" value=\"Pridať\"/></form>";
				break;
			default:
		    }
		    echo projects_temy_table($course, $cm);
	    } else {
		    if($groups = groups_get_all_groups($course->id)) {
			    foreach($groups as &$g) {
				    echo projects_get_theme_table($course, $g, $cm);
			    }
		    } else {
			    error('nepodarilo sa načítať žiadne skupiny');
		    }
	    }
    } else {

	    // registracia temy

	    $tema_reg = optional_param('tema_reg');
	    if($tema_reg && get_record('projects_temy', 'id', $tema_reg, 'course_id', $course->id)) projects_tema_register($tema_reg);

	    // odovzdavanie tem studentmi
	    
	    if(optional_param('tema_odovzdaj')) {
		    if(optional_param('hotovo')) {

			    $uploads_dir = $CFG->dirroot.'/mod/projects/odovzdane_subory/';
			    if(!file_exists($uploads_dir)) mkdir($uploads_dir, 0777, true);
			    if(!empty($_FILES["doc_file"]["tmp_name"])) {
				    $tmp_name = $_FILES["doc_file"]["tmp_name"];
				    $name = "uid-$USER->id-".$_FILES["doc_file"]["name"];
				    move_uploaded_file($tmp_name, "$uploads_dir/$name");
				    if(!projects_tema_odovzdat($course, $name)) error("odovzdanie neúspešné");
			    }
		    } else {
			    header('Location: file.php?id='.$cm->id.'a=up');
			    die();
		    }
	    }

	    if($groups = groups_get_all_groups($course->id)) {
		foreach($groups as &$g) {
			if(groups_is_member($g->id)) echo '<br />'.projects_get_theme_table($course, $g, $cm);
		}
	    } else {
		    error('nepodarilo sa načítať žiadne skupiny');
	    }
    }

    echo '<div style="clear:both" />';
    echo "<br />";
    echo "<br />";
    echo "<br />";

    /*
    echo "<br />";
    echo "<br />";
    echo '<table border="1">';
    echo '<tr><th>Číslo</th><th>Názov témy</th><th>&nbsp;</th></tr>';
    echo '<tr><td>1</td><td>Riadenie prístupu v OS Windows XP</td><td><a href="#">registruj</a></td></tr>';
    echo '<tr><td>2</td><td>Riadenie prístupu v OS UNIX</td><td><a href="#">registruj</a></td></tr>';
    echo '<tr><td>3</td><td>Forenzné nástroje na zber stálych digitálnych dôkazov</td><td><a href="#">registruj</a></td></tr>';
    echo '<tr><td>4</td><td>Forenzné nástroje na zber nestálych digitálnych dôkazov</td><td><a href="#">registruj</a></td></tr>';
    echo '<tr><td>5</td><td>Vírusové infiltrácie</td><td><a href="#">registruj</a></td></tr>';
    echo '<tr><td>6</td><td>Infraštruktúra verejného kľúča (PKI)</td><td><a href="#">registruj</a></td></tr>';
    echo '<tr><td>7</td><td>Bezpečnosť čipových kariet</td><td><a href="#">registruj</a></td></tr>';
    echo '<tr><td>8</td><td>Metódy identifikácie a autentizácie používateľov</td><td><a href="#">registruj</a></td></tr>';
    echo '<tr><td>9</td><td>Bezpečnosť v databáze PosgreSQL</td><td><a href="#">registruj</a></td></tr>';
    echo '<tr><td>10</td><td>Bezpečnosť v bezdrátových (wireless) LAN</td><td><a href="#">registruj</a></td></tr>';
    echo '<tr><td>11</td><td>Personálne bezpečnostné brány</td><td><a href="#">registruj</a></td></tr>';
    echo '<tr><td>12</td><td>Auditné záznamy - nastavenie politiky, filtrovanie, vyhodnocovanie</td><td><a href="#">registruj</a></td></tr>';
    echo '</table>';
     */


/// Finish the page
    print_footer($course);

?>
